//
//  PTMainTabBarVC.swift
//  WirelessPrinter
//
//  Created by midmirror on 16/5/27.
//  Copyright © 2016年 midmirror. All rights reserved.
//

import Foundation
import UIKit

open class PTMainTabBarVC: UITabBarController {
    
    open var budgeValue: String?
    open var tabBarIndex: Int?
    var sessionItem: UITabBarItem?
    
    open override func viewDidLoad() {
        
        super.viewDidLoad()
        
        let commandVC = PTCommandVC()
        let bitmapVC = PTBitmapVC()
        let commandItem = UITabBarItem.init(title: NSLocalizedString("Command", comment: ""), image: UIImage.init(named: "printer_tabbar_gray"), selectedImage: UIImage.init(named: "printer_tabbar_blue"))
        
        let bitmapItem = UITabBarItem.init(title: NSLocalizedString("Bitmap", comment: ""), image: UIImage.init(named: "bitmap_tabbar_gray"), selectedImage: UIImage.init(named: "bitmap_tabbar_blue"))
        
        commandVC.tabBarItem = commandItem
        bitmapVC.tabBarItem = bitmapItem
        
        let commandNC = UINavigationController.init(rootViewController: commandVC)
        let bitmapNC  = UINavigationController.init(rootViewController: bitmapVC)
        
        self.setViewControllers([commandNC,bitmapNC], animated: true)
    }
    
    open override func viewWillAppear(_ animated: Bool) {
        
        super.viewWillAppear(true)
    }
    
    open func setBudgeValue(_ budgeValue: String, tabBarIndex: Int) {
        
        self.budgeValue = budgeValue
        self.tabBarIndex = tabBarIndex
    }
    
    open override func tabBar(_ tabBar: UITabBar, didSelect item: UITabBarItem) {
        
        if item == sessionItem {
            
        } else {
            
        }
    }
    
//    public func setBadgeValue(badgeValue: String, tabBarIndex: Int) {
//        
//        print(self.viewControllers![tabBarIndex])
//        self.viewControllers![tabBarIndex].tabBarItem.badgeValue = badgeValue
//    }
    
}
