//
//  PTTestTSC.m
//  WirelessPrinter
//
//  Created by midmirror on 16/3/3.
//  Copyright © 2016年 midmirror. All rights reserved.
//

#import "PTTestTSC.h"
#import <PrinterSDK/PrinterSDK.h>
#import "PTPrinterPort.h"
#import "ProgressHUD.h"
#import "PTLabelAppend.h"
#import "PTScaleImage.h"

@implementation PTTestTSC

- (void)CLS {
    
    PTCommandTSPL *cmd = [[PTCommandTSPL alloc] init];
    
    [cmd setCLS];
    
    [PTPrinterPort sendData:cmd.cmdData];
}

/** 打印菜鸟定制模板 */
- (void)printCaiNiaoTemplate {
    
    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"PrinterResource.bundle/ShunFeng" ofType:@"txt"];
    NSMutableString *source = [[NSMutableString alloc] initWithContentsOfFile:filePath encoding:NSUTF8StringEncoding error:nil];
    
    // 顺丰、百世汇通、韵达、圆通、德邦
    NSArray *expressCompanys = @[@"SF",@"BSHT",@"YD",@"YT",@"CY"];
    
    PTLabelAppend *label = [[PTLabelAppend alloc] init];
    label.collection        = @"25 元";
    label.code_number       = @"021D-123-789";
    label.barcode           = @"AFC7150124715012424";
    label.barcode_text      = @"AFC7150124715012424";
    label.distributing      = @"黑龙江齐齐哈尔集散";
    label.receiver          = @"齐齐哈尔木鱼";
    label.receiver_contact  = @"15605883677 0571-53992320";
    label.receiver_address  = @"黑龙江齐齐哈尔市建华区文化大街42号齐齐哈尔大学计算机工程学院001班";
    label.sender            = @"浙江杭州行者";
    label.sender_contact    = @"18000989090 0571-53992320";
    label.sender_address    = @"浙江省杭州市余杭区文一西路1001号阿里巴巴淘宝城5号办公楼5号小邮局";
    label.qrcode            = @"扫码有惊喜";
    label.qrcode_text       = @"扫码有惊喜";
    label.express_company   = expressCompanys[0];
    
    NSMutableData *muData = [[NSMutableData alloc] initWithData:[source dataUsingEncoding:NSUTF8StringEncoding]];
    [muData appendData:[label dataWithTSPL]];
    [PTPrinterPort sendData:muData];
}

- (void)printZhongTongTemplate {
    
    PTLabelAppend *label = [[PTLabelAppend alloc] init];
    
    label.collection        = @" 29995";
    label.barcode           = @"360 024 139 575";
    label.distributing      = @"哈尔滨转齐齐哈尔";
    label.date              = @"2015-12-24";
    
    label.receiver          = @"肖凤财";
    label.receiver_contact  = @"13590000000";
    label.receiver_address  = @"上海 上海市 青浦区 华新镇华志路100号 XX住宅区XX栋XX单元XX室";
    label.receiver_message  = @"肖凤财 13590000000 广东省深圳市南山区南山软件产业基地1栋B座16楼";
    
    label.sender            = @"李小小";
    label.sender_contact    = @"021-69783707";
    label.sender_address    = @"上海 上海市 青浦区 华新镇华志路1684号中通快递";
    label.sender_message    = @"李小小 13590000000 广东省深圳市南山区南山软件产业基地1栋B座16楼";
    
    label.article_name      = @"衣服衣服";
    label.article_weight    = @"210（kg）";
    
    label.amount_declare    = @"29995.98";
    label.amount_paid       = @"29995.98";
    label.amount_paid_advance = @"29995.98";
    
    label.delivery_number   = @"360024139575";
    label.order_number      = @"LP00001856854523";
    label.print_time        = @"2015-12-28";
    label.express_company   = @"ZHONGTONG";
    
    NSData *labelData = [label dataWithTSPL];
    
    NSLog(@"%@",[PTEncode decodeStringWithData:labelData]);
    
    // 二、读入模板
    NSString *path = [[NSBundle mainBundle] pathForResource:@"ZhongTong" ofType:@"txt"];
    NSData *templateData = [label dataWithSourceFile:path];
    
    // 三、合并模板和数据
    NSMutableData *finalData = [[NSMutableData alloc] initWithData:templateData];
    [finalData appendData:labelData];
    
    // 四、发送打印
    [PTPrinterPort sendData:finalData];
}


- (void)printShenTongTemplate {
    
    PTLabelAppend *label = [[PTLabelAppend alloc] init];
    
    label.barcode           = @"363604310467";
    label.distributing      = @"上海 上海市 长宁区";
    
    label.receiver_name     = @"申大通";
    label.receiver_phone    = @"13826514987";
    label.receiver_address  = @"上海市宝山区共和新路4719弄共和小区12号306室";
    
    label.sender_name       = @"快小宝";
    label.sender_phone      = @"13826514987";
    label.sender_address    = @"上海市长宁区北瞿路1178号（鑫达商务楼）1号楼305室";
    label.express_company   = @"SHENTONG";
    
    NSData *labelData = [label dataWithTSPL];
    
    // 二、读入模板
    NSString *path = [[NSBundle mainBundle] pathForResource:@"ShenTong" ofType:@"txt"];
    NSData *templateData = [label dataWithSourceFile:path];
    
    // 三、合并模板和数据
    NSMutableData *finalData = [[NSMutableData alloc] initWithData:templateData];
    [finalData appendData:labelData];
    
    // 四、发送打印
    [PTPrinterPort sendData:finalData];
}

/**
 *  返回值 -1 未定义
 0  正常
 1  无纸
 2  开盖
 */
- (void)testCaiNiaoGetPaperStatus:(GetPaperStatusBlock)statusBlock {
    
    self.statusBlock = statusBlock;
    
    NSData *cmdData = [PTLabel getPaperStauts];
    
    [ProgressHUD show:@"查询..."];
    [[PTDispatcher share] sendData:cmdData];
    [[PTDispatcher share] whenReceiveData:^(NSData *receiveData) {
        
        NSLog(@"当前纸张状态:%@",receiveData);
        
        NSData *status1 = [NSData dataWithBytes:"\x00" length:1];
        NSData *status2 = [NSData dataWithBytes:"\x04" length:1];
        NSData *status3 = [NSData dataWithBytes:"\x41" length:1];
        NSData *status4 = [NSData dataWithBytes:"\x45" length:1];
        
        if ([receiveData isEqualToData:status1]) {
            
            self.statusBlock(PTPaperStatusNormal);
            
            [self printCaiNiaoTemplate];
            
        }else if ([receiveData isEqualToData:status2]) {
            
            self.statusBlock(PTPaperStatusLidOpen);
            
        }else if ([receiveData isEqualToData:status3]) {
            
            self.statusBlock(PTPaperStatusPaperNull);
            
        }else if ([receiveData isEqualToData:status4]) {
            
            self.statusBlock(PTPaperStatusPaperNull);
        }else {
            
            self.statusBlock(PTPaperStatusUnknown);
        }
        
        [ProgressHUD dismiss];
    }];
}

- (void)selfTest {
    
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc selfTest];
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printText {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc setPrintAreaSizeWithWidth:100 Height:100];
    [tsc setCLS];
    
    [tsc appendTextWithXPos:0 YPos:0 FontSize:16 Rotation:0 Text:@"16号字体"];
    [tsc appendTextWithXPos:0 YPos:20 FontSize:20 Rotation:0 Text:@"20号字体"];
    [tsc appendTextWithXPos:0 YPos:40 FontSize:24 Rotation:0 Text:@"24号字体"];
    [tsc appendTextWithXPos:0 YPos:60 FontSize:28 Rotation:0 Text:@"28号字体"];
    [tsc appendTextWithXPos:0 YPos:80 FontSize:32 Rotation:0 Text:@"32号字体"];
    [tsc appendTextWithXPos:0 YPos:120 FontSize:40 Rotation:0 Text:@"40号字体"];
    [tsc appendTextWithXPos:0 YPos:160 FontSize:48 Rotation:0 Text:@"48号字体"];
    [tsc appendTextWithXPos:0 YPos:200 FontSize:56 Rotation:0 Text:@"56号字体"];
    
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

// 打印反白文本
- (void)printReverseText {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc setPrintAreaSizeWithWidth:100 Height:80];
    [tsc setGapWithDistance:0 Offset:0];
    [tsc setSpeed:6];
    [tsc setDensity:8];
    [tsc setDirection:0 Mirror:0];
    [tsc setCLS];
    [tsc printTextWithXPos:10 YPos:10 Font:@"3" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"REVERSE"];
    [tsc setReverseWithXStart:0 YStart:0 XWidth:100 YHeight:40];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printBar {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc setPrintAreaSizeWithWidth:1100 Height:30];
    [tsc setPrintAreaSizeWithWidth:0 Height:0];
    [tsc setSpeed:6];
    [tsc setDensity:8];
    [tsc setDirection:0 Mirror:0];
    [tsc setCLS];
    [tsc printBarWithXPos:0 YPos:0 Width:1000 Height:20];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printBarcode {
    
//    BARCODE 100,100,"39",96,1,0,2,4,"1000"
//    BARCODE 10,10,"128M",48,1,0,2,2,"!104!096ABCD!101EFGH"
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    NSArray *barcodeTypeArray = @[@"128",@"128M",@"EAN128",@"25",@"25C",@"39",@"39C",@"39S",@"93"];

    for (int i = 0; i<barcodeTypeArray.count; i++) {
        
        [tsc setPrintAreaSizeWithWidth:100 Height:10];
        [tsc setCLS];
        [tsc printBarcodeWithXPos:0 YPos:0 Type:barcodeTypeArray[i] Height:50 HumanReadable:0 Rotation:0 Narrow:2 Wide:2 CodeNumber:@"123456789"];
        
        [tsc printWithSets:1 Copies:1];
    }
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printBox {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];

    [tsc setPrintAreaSizeWithWidth:100 Height:100];
    [tsc setPrintAreaSizeWithWidth:0 Height:0];
    [tsc setSpeed:6];
    [tsc setDirection:0 Mirror:0];
    [tsc setCLS];
    [tsc setBoxWithXStart:10 YStart:10 XEnd:200 YEnd:90 Thickness:5];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printCircle {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];

    [tsc setPrintAreaSizeWithWidth:1100 Height:100];
    [tsc setPrintAreaSizeWithWidth:0 Height:0];
    [tsc setSpeed:6];
    [tsc setDirection:0 Mirror:0];
    [tsc setCLS];
    [tsc setCircleWithXStart:10 YStart:10 Diameter:100 Thickness:10];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printDMatix {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc setPrintAreaSizeWithWidth:1000 Height:150];
    [tsc setPrintAreaSizeWithWidth:0 Height:0];
    [tsc setSpeed:4];
//    [tsc setDensity:8];
    [tsc setDirection:0 Mirror:0];
//    [tsc setReferenceXPos:@"0" YPos:@"0"];
//    [tsc setOffsetWithDistance:@"0.00"];
    //set cutter off
    [tsc setTearON];
    [tsc setCLS];
    [tsc setDmatrixWithExpression:@"DMATRIX 1" XPos:10 YPos:10 Width:100 Height:100 XM:nil Row:nil Col:nil];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printErase {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];

    [tsc setPrintAreaSizeWithWidth:1000 Height:100];
    [tsc setPrintAreaSizeWithWidth:0 Height:0];
    [tsc setSpeed:6];
    [tsc setDensity:8];
    [tsc setDirection:0 Mirror:0];
    [tsc setCLS];
    [tsc printBarWithXPos:100 YPos:100 Width:300 Height:300];
    [tsc setEraseWithXStart:150 YStart:150 XWidth:200 YHeight:200];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printMaxicode {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc setPrintAreaSizeWithWidth:1000 Height:100];
    [tsc setPrintAreaSizeWithWidth:0 Height:0];
    [tsc setCLS];
    [tsc setSpeed:4];
    [tsc setDensity:8];
    [tsc setOffsetWithDistance:0.00];
    [tsc setCutterOFF];
    [tsc setTearON];
    
    [tsc setMaxicode:@"MaxiCode" XPos:10 YPos:10 Mode:2 Class:300 Country:840 Post:@"06810" LM:7317];
//    [tsc printText:@"MaxiCode" X:@"20" Y:@"20" Font:@"3" Rotation:@"0" XMultiplication:@"2" YMultiplication:@"2"];
    [tsc printWithSets:1 Copies:1];
    
    [tsc setCLS];
    [tsc setMaxicode:@"MaxiCode 2" XPos:10 YPos:10 Mode:4 Class:300 Country:863 Post:@"107317" LM:107317];
//    [tsc printText:@"Demo 3 for Canada Maxicode" X:@"30" Y:@"30" Font:@"3" Rotation:@"0" XMultiplication:@"2" YMultiplication:@"2"];
    
    
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printPDF417 {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];

    [tsc setPrintAreaSizeWithWidth:1000 Height:100];
    [tsc setPrintAreaSizeWithWidth:0 Height:0];
    [tsc setCLS];
    [tsc setSpeed:6];
    [tsc setDensity:8];
    [tsc setDirection:1 Mirror:0];
    [tsc setReferenceXPos:0 YPos:0];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:10 YPos:10 Width:200 Height:200 Rotate:0 Option:nil Expression:@"Without Options"];
    [tsc printWithSets:1 Copies:1];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:10 YPos:10 Width:200 Height:200 Rotate:0 Option:@"E4" Expression:@"Error correction level:4"];
    [tsc printWithSets:1 Copies:1];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:10 YPos:10 Width:200 Height:200 Rotate:0 Option:@"E4,W4" Expression:@"Error correction level:4 module width 4 dots"];
    [tsc printWithSets:1 Copies:1];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:10 YPos:10 Width:200 Height:200 Rotate:0 Option:@"E4,W4,H4,R25" Expression:@"Error correction level:4 Module Width 4 dots"];
    [tsc printWithSets:1 Copies:1];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:10 YPos:10 Width:200 Height:200 Rotate:0 Option:@"E4,W4,H4,R40,C3" Expression:@"Error correction level:4 Module Width 4 dots"];

    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printReceipt {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];

    [tsc setPrintAreaSizeWithWidth:100 Height:80];
    [tsc setCLS];
    [tsc printTextWithXPos:0 YPos:0 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"厦门汉印电子科技技术有限公司"];
    [tsc printTextWithXPos:0 YPos:30 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"日期：2016-08-20"];
    [tsc printTextWithXPos:0 YPos:60 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"客户：厦门普瑞特"];
    [tsc printTextWithXPos:0 YPos:90 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"仓库：二楼A仓库"];
    [tsc printTextWithXPos:0 YPos:120 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"经手人：小张"];
    [tsc printTextWithXPos:0 YPos:150 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"----------------------"];
    [tsc printTextWithXPos:0 YPos:180 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"MPT-II         777.00"];
    [tsc printTextWithXPos:0 YPos:210 Font:@"0" Rotation:0 XMultiplication:1 YMultiplication:1 Text:@"MPT-III        888.00"];
    
    
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printQRCode {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];

    [tsc setPrintAreaSizeWithWidth:100 Height:80];
    [tsc setCLS];
    [tsc printQRcodeWithXPos:0 YPos:0 EccLevel:@"L" CellWidth:15 Mode:@"M" Rotation:0 Model:@"M1" Mask:@"S1" Text:@"Hello world"];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printBitmap {
    
    UIImage *image = [UIImage imageNamed:@"emeya.jpg"];
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    NSData *bmpData = [PTBitmap getImageData:image.CGImage mode:PTBitmapModeDithering compress:PTBitmapCompressModeNone];
    
    [tsc setPrintAreaSizeWithWidth:100 Height:80];
    [tsc setCLS];
    [tsc addBitmapWithXPos:0 YPos:0 width:image.size.width height:image.size.height Mode:1 imageData:bmpData];
    [tsc printWithSets:1 Copies:1];
    
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printLabel {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc setPrintAreaSizeWithWidth:80 Height:150];
    [tsc setDirection:0 Mirror:0];
    [tsc setReferenceXPos:0 YPos:0];
    [tsc setPeelOFF];
    [tsc setTearON];
    [tsc setCLS];
    
    [tsc printBarcodeWithXPos:300 YPos:30 Type:@"128" Height:64 HumanReadable:1 Rotation:0 Narrow:3 Wide:7 CodeNumber:@"363604310467"];
    [tsc printBarWithXPos:16 YPos:144 Width:600 Height:3];
    [tsc printTextWithXPos:32 YPos:160 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"收件："];
    [tsc printTextWithXPos:110 YPos:156 Font:@"1" Rotation:1 XMultiplication:2 YMultiplication:2 Text:@"上海市长宁区北翟路1178号（鑫达商"];
    [tsc printTextWithXPos:110 YPos:196 Font:@"1" Rotation:1 XMultiplication:2 YMultiplication:2 Text:@"务楼）1号楼305室"];
    [tsc printTextWithXPos:110 YPos:236 Font:@"1" Rotation:1 XMultiplication:2 YMultiplication:2 Text:@"快小宝 13826514987"];
    [tsc printBarWithXPos:32 YPos:280 Width:560 Height:3];
    [tsc printTextWithXPos:32 YPos:300 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"发件："];
    [tsc printTextWithXPos:110 YPos:300 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"上海市宝山区共和新4719弄共和小区13号"];
    [tsc printTextWithXPos:110 YPos:340 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"306室"];
    [tsc printTextWithXPos:110 YPos:380 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"沈一峰 13965421578"];
    
    [tsc printBarWithXPos:16 YPos:420 Width:600 Height:3];
    
    [tsc printTextWithXPos:60 YPos:440 Font:@"0" Rotation:1 XMultiplication:2 YMultiplication:3 Text:@"上海 上海市 长宁区"];
    [tsc printBarWithXPos:16 YPos:530 Width:600 Height:3];
    
    [tsc printTextWithXPos:32 YPos:550 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"物品："];
    [tsc printTextWithXPos:110 YPos:550 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"办公室迷你风"];
    
    [tsc printTextWithXPos:110 YPos:590 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"扇"];
    [tsc printTextWithXPos:32 YPos:630 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"日期：2015-07-05"];
    [tsc printBarWithXPos:360 YPos:530 Width:2 Height:150];
    [tsc printTextWithXPos:376 YPos:550 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"签字："];
    [tsc printTextWithXPos:440 YPos:630 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"年    月    日"];
    [tsc printTextWithXPos:32 YPos:700 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"收件："];
    
    //
    [tsc printTextWithXPos:110 YPos:692 Font:@"1" Rotation:1 XMultiplication:2 YMultiplication:2 Text:@"上海市长宁区北翟路1178号（鑫达商"];
    [tsc printTextWithXPos:110 YPos:732 Font:@"1050629" Rotation:1 XMultiplication:2 YMultiplication:2 Text:@"务楼）1号楼305室"];
    [tsc printTextWithXPos:110 YPos:772 Font:@"1" Rotation:1 XMultiplication:2 YMultiplication:2 Text:@"快小宝 13826514987"];
    [tsc printBarWithXPos:32 YPos:820 Width:560 Height:3];
    [tsc printTextWithXPos:32 YPos:834 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"发件："];
    [tsc printTextWithXPos:110 YPos:830 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"上海市宝山区共和新4719弄共和小区13号"];
    [tsc printTextWithXPos:110 YPos:870 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"306室"];
    [tsc printTextWithXPos:110 YPos:910 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"沈一峰 13965421578"];
    
    [tsc printBarWithXPos:16 YPos:950 Width:600 Height:3];
    
    [tsc printTextWithXPos:32 YPos:970 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"物品："];
    [tsc printTextWithXPos:110 YPos:970 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"办公室迷你风扇"];
    
    [tsc printTextWithXPos:32 YPos:1010 Font:@"0" Rotation:1 XMultiplication:1 YMultiplication:1 Text:@"日期：2015-07-05"];
    [tsc printBarWithXPos:16 YPos:1050 Width:600 Height:3];
    [tsc printBarcodeWithXPos:72 YPos:1066 Type:@"128" Height:80 HumanReadable:1 Rotation:0 Narrow:5 Wide:9 CodeNumber:@"363604310467"];

    
    [tsc printWithSets:1 Copies:1];
    [PTPrinterPort sendData:tsc.cmdData];
}

- (void)printZhongJiTemplate {
    
    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"PrinterResource.bundle/ZJ_TSPL" ofType:@"txt"];
    NSMutableString *source = [[NSMutableString alloc] initWithContentsOfFile:filePath encoding:NSUTF8StringEncoding error:nil];
    
    PTLabelAppend *label = [[PTLabelAppend alloc] init];
    label.collection        = @"25 元";
    label.code_number       = @"021D-123-789";
    label.barcode           = @"AFC7150124715012424";
    label.distributing      = @"黑龙江齐齐哈尔集散";
    label.receiver          = @"齐齐哈尔木鱼";
    label.receiver_contact  = @"15605883677 0571-53992320";
    label.receiver_address  = @"黑龙江齐齐哈尔市建华区文化大街42号齐齐哈尔大学计算机工程学院001班";
    label.sender            = @"浙江杭州行者";
    label.sender_contact    = @"18000989090 0571-53992320";
    label.sender_address    = @"浙江省杭州市余杭区文一西路1001号阿里巴巴淘宝城5号办公楼5号小邮局";
    label.qrcode            = @"扫码有惊喜";
    label.qrcode_text       = @"扫码有惊喜";
    
    NSMutableData *muData = [[NSMutableData alloc] init];
    [muData appendData:[label getTemplateData:source labelDict:nil]];

    UIImage *cainiaoLogo = [UIImage imageNamed:[[NSBundle mainBundle] pathForResource:@"PrinterResource.bundle/cainiao" ofType:@"jpg"]];
    UIImage *stoLogo = [UIImage imageNamed:[[NSBundle mainBundle] pathForResource:@"PrinterResource.bundle/logo_sto" ofType:@"png"]];
    UIImage *scaleStoLogo = [PTScaleImage scaleSourceImage:stoLogo maxWidth:150];
    

    PTCommandTSPL *cmd = [[PTCommandTSPL alloc] init];
    NSData *cainiaoLogoData = [PTBitmap getImageData:cainiaoLogo.CGImage mode:PTBitmapModeBinary compress:PTBitmapCompressModeNone];
    NSData *stoLogoData = [PTBitmap getImageData:scaleStoLogo.CGImage mode:PTBitmapModeBinary compress:PTBitmapCompressModeNone];
    
    NSData *cainiaoLogoNagativeData = [PTBitmap negativeData:cainiaoLogoData];
    NSData *stoLogoNagativeData = [PTBitmap negativeData:stoLogoData];
    
    [cmd addBitmapWithXPos:5 YPos:5 width:scaleStoLogo.size.width height:scaleStoLogo.size.height Mode:1 imageData:stoLogoNagativeData];
    [cmd addBitmapWithXPos:34 YPos:912 width:cainiaoLogo.size.width height:cainiaoLogo.size.height Mode:1 imageData:cainiaoLogoNagativeData];
    [cmd printWithSets:1 Copies:1];
    
    [muData appendData:cmd.cmdData];
    
    [PTPrinterPort sendData:muData];
}

@end
